using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.AudioVideoPlayback;

namespace MechanikElementar
{
    public partial class Form1 : Form
    {
        private float x, y;
        private float vx, vy;
        private const float xPlanet = 150.0f;
        private const float yPlanet = 330.0f;
        private DateTime lastTime = DateTime.Now;
        private Bitmap bitmap;
        private Graphics graphics;
        private Audio audio = new Audio(@"..\..\tumpf.wav");
        private bool soundPlayed;

        public Form1()
        {
            InitializeComponent();
            bitmap = new Bitmap(ClientSize.Width, ClientSize.Height);
            graphics = Graphics.FromImage(bitmap);

            x = 10.0f; // Pixel
            y = 300.0f; // Pixel
            vx = 40.0f; // Pixel pro Sekunde
            vy = -50.0f; // Pixel pro Sekunde
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            graphics.FillEllipse(Brushes.LightGray, x, y, 10.0f, 10.0f);

            DateTime thisTime = DateTime.Now;
            float dt = (float)((thisTime-lastTime).TotalSeconds);
            //System.Diagnostics.Debug.WriteLine(dt);
            lastTime = thisTime;

            x += vx*dt;
            y += vy*dt;

            // schrger Wurf mit Luftreibung
            vx += -0.2f*vx*dt;
            vy += -0.2f*vy*dt + 5.0f*dt; // 5 Pixel/s^2
            Text = vy.ToString();

            if (y >= ClientSize.Height && !soundPlayed)
            {
                audio.Play();
                soundPlayed = true;
            }

            /*
            // Satellitenbewegung
            // hoher Diskretisierungsfehler!!
            float r2 = (x - xPlanet) * (x - xPlanet) + (y - yPlanet) * (y - yPlanet);
            float r = (float)Math.Sqrt(r2);
            vx += -20000.0f / r2 * (x - xPlanet) / r;
            vy += -20000.0f / r2 * (y - yPlanet) / r;
            */

            e.Graphics.DrawImage(bitmap, 0, 0);
            e.Graphics.FillEllipse(Brushes.Red, x, y, 10.0f, 10.0f);
            //e.Graphics.FillEllipse(Brushes.Blue, xPlanet, yPlanet, 10.0f, 10.0f);

            Invalidate();
        }
    }
}